﻿using LitJson;
using System;
using Viveport;

namespace Htc.Demo
{
    class ViveportDemo
    {
        private static IAPListener mListenerIAP = new IAPListener();
        static string VIVEPORT_ID = "bd67b286-aafc-449d-8896-bb7e9b351876";
        static string VIVEPORT_KEY = "MIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDFypCg0OHf"
                                + "BC+VZLSWPbNSgDo9qg/yQORDwGy1rKIboMj3IXn4Zy6h6bgn"
                                + "8kiMY7VI0lPwIj9lijT3ZxkzuTsI5GsK//Y1bqeTol4OUFR+"
                                + "47gj+TUuekAS2WMtglKox+/7mO6CA1gV+jZrAKo6YSVmPd+o"
                                + "FsgisRcqEgNh5MIURQIDAQAB";
        static string IAP_KEY = "app_iap_key";//replace it with your app key

        private static void testGetLicense()
        {
            Api.GetLicense(new MyLicenseChecker(), VIVEPORT_ID, VIVEPORT_KEY);
        }

        private static void testStatIsReady()
        {
            Console.WriteLine("==== StatIsReady => " + UserStats.IsReady(IsReadyHandler) + "====\n");
            displayMenuItems();
        }

        private static void testGetUserId()
        {
            Console.WriteLine("==== GetUserId => " + User.GetUserId() + "=====\n");
        }

        private static void testGetUserName()
        {
            Console.WriteLine("==== GetUserName => " + User.GetUserName() + "=====\n");
        }

        private static void testGetUserAvatarUrl()
        {
            Console.WriteLine("==== GetUserAvatarurl => " + User.GetUserAvatarUrl() + "=====\n");
            displayMenuItems();
        }

        private static void testArcadeSessionIsReady()
        {
            Console.WriteLine("==== testArcadeSessionIsReady ====");
            //Session.IsReady(mListener);
        }

        private static void testArcadeSessionStart()
        {
            Console.WriteLine("==== testArcadeSessionStart ====");
            //Session.Start(mListener);
        }

        private static void testArcadeSessionStop()
        {
            Console.WriteLine("==== testArcadeSessionStop ====");
            //Session.Stop(mListener);
        }


        private static void testDownloadStatAPI()
        {
            Console.WriteLine("==== DownloadStat => " + UserStats.DownloadStats(DownloadStatHandler) + "====");
        }

        private static void testUploadStatAPI()
        {
            Console.WriteLine("==== UploadStat => " + UserStats.UploadStats(UploadStatHandler) + "====");
        }

        private static void testDownloadLeaderboard()
        {
            Console.WriteLine("==== DownloadLeaderboard => " + UserStats.DownloadLeaderboardScores(DownloadLeaderboardHandler, "ID_Leaderboard1", UserStats.LeaderBoardRequestType.GlobalDataAroundUser, UserStats.LeaderBoardTimeRange.AllTime, -5, 5) + "====");
        }

        private static void testUploadLeaderboard()
        {
            Console.WriteLine("==== UploadLeaderboard => " + UserStats.UploadLeaderboardScore(UploadLeaderboardHandler, "ID_Leaderboard1", 500) + "====");
        }

        private static void testDownloadArcadeLeaderboard()
        {
            int score = 10;
            Console.WriteLine("==== DownloadArcadeLeaderboard ====");
            ArcadeLeaderboard.DownloadLeaderboardScores(DownloadArcadeLeaderboardHandler, "ID_Leaderboard1", ArcadeLeaderboard.LeaderboardTimeRange.AllTime, score);
        }

        private static void testUploadArcadeLeaderboard()
        {
            Console.WriteLine("==== UploadArcadeLeaderboard ====");
            ArcadeLeaderboard.UploadLeaderboardScore(UploadArcadeLeaderboardHandler, "ID_Leaderboard1", "Karl Chen", 500);
        }

        private static void testIAPIsReady()
        {
            Console.WriteLine("==== testIAPIsReady ====");
            IAPurchase.IsReady(mListenerIAP, IAP_KEY);
        }

        public static void testIAPRequest()
        {
            Console.WriteLine("==== testIAPRequest ====");
            //add virtual items into cache
            mListenerIAP.mItem.items = new string[3];
            mListenerIAP.mItem.items[0] = "sword";
            mListenerIAP.mItem.items[1] = "knife";
            mListenerIAP.mItem.items[2] = "medicine";
            IAPurchase.Request(mListenerIAP, "1");
        }

        public static void testIAPRequestWithUserData()
        {
            Console.WriteLine("==== testIAPRequestWithUserData ====");
            //add virtual items into cache
            mListenerIAP.mItem.items = new string[3];
            mListenerIAP.mItem.items[0] = "sword";
            mListenerIAP.mItem.items[1] = "knife";
            mListenerIAP.mItem.items[2] = "medicine";
            IAPurchase.Request(mListenerIAP, "1", "sword,knife,medicine");
        }

        public static void testIAPPurchase()
        {
            Console.WriteLine("==== testIAPPurchase ====");
            IAPurchase.Purchase(mListenerIAP, mListenerIAP.mItem.ticket);
        }

        public static void testIAPQuery()
        {
            Console.WriteLine("==== testIAPQuery ====");
            IAPurchase.Query(mListenerIAP, mListenerIAP.mItem.ticket);
        }

        public static void testIAPGetbalance()
        {
            Console.WriteLine("==== testIAPGetbalance ====");
            IAPurchase.GetBalance(mListenerIAP);
        }

        public static void testIAPRequestSubscription()
        {
            Console.WriteLine("==== testIAPRequestSubscription ====");
            IAPurchase.RequestSubscription(mListenerIAP, "1", "month", 1, "day", 2, 3, "pID");
        }

        public static void testIAPRequestSubscriptionwithplanID()
        {
            Console.WriteLine("==== testIAPRequestSubscriptionwithplanID ====");
            IAPurchase.RequestSubscriptionWithPlanID(mListenerIAP, "pID");
        }

        public static void testIAPsubscribe()
        {
            Console.WriteLine("==== testIAPsubscribe ====");
            IAPurchase.Subscribe(mListenerIAP, mListenerIAP.mItem.subscription_ticket);
        }

        public static void testIAPQureysubscription()
        {
            Console.WriteLine("==== testIAPQureysubscription ====");
            IAPurchase.QuerySubscription(mListenerIAP, mListenerIAP.mItem.subscription_ticket);
        }

        public static void testIAPCancelsubscription()
        {
            Console.WriteLine("==== testIAPCancelsubscription ====");
            IAPurchase.CancelSubscription(mListenerIAP, mListenerIAP.mItem.subscription_ticket);
        }

        private static void TokenIsReadyHandler(int nResult)
        {
            Console.WriteLine("==== Token IsReady ====");
            if (nResult == 0)
                Console.WriteLine("TokenIsReadyHandler result is successful ");
            else
                Console.WriteLine("TokenIsReadyHandler result is fail");
            showMenu();
        }

        public static void testTokenIsReady()
        {
            Console.WriteLine("==== testTokenIsReady ====");
            Token.IsReady(TokenIsReadyHandler);
        }

        private static void GetSessionTokenHandler(int nResult, string message)
        {
            if (nResult == 0)
            {
                Viveport.Core.Logger.Log("GetSessionTokenHandler is successful, token:" + message);
            }
            else
            {
                if (message.Length != 0)
                {
                    Viveport.Core.Logger.Log("GetSessionTokenHandler error: " + nResult + ", message:" + message);
                }
                else
                {
                    Viveport.Core.Logger.Log("GetSessionTokenHandler error: " + nResult);
                }
            }
            showMenu();
        }

        public static void testGetSessionToken()
        {
            Console.WriteLine("==== testGetSessionToken ====");
            Token.GetSessionToken(GetSessionTokenHandler);
        }

        public static void testQueryPurchaseList()
        {
            Console.WriteLine("==== testQueryPurchaseList ====");
            IAPurchase.Query(mListenerIAP);
        }

        public static void ReadKeyShowMenu()
        {
            Console.WriteLine("Please press any key to show function menu");
            Console.ReadKey();
            showMenu();
        }

        public static int showMenu()
        {
            /*Displays the menu to user*/
            displayMenuItems();
            ConsoleKeyInfo input;
            bool bexit = false;
            do
            {
                input = Console.ReadKey();
                Console.WriteLine("KeyPress =  " + input.Key);
                switch (input.Key)
                {
                    case ConsoleKey.NumPad0:
                    case ConsoleKey.D0:
                        testGetLicense();
                        break;
                    case ConsoleKey.NumPad1:
                    case ConsoleKey.D1:
                        testStatIsReady();
                        break;
                    case ConsoleKey.NumPad2:
                    case ConsoleKey.D2:
                        testGetUserId();
                        testGetUserName();
                        testGetUserAvatarUrl();
                        break;
                    case ConsoleKey.NumPad3:
                    case ConsoleKey.D3:
                        testDownloadStatAPI();
                        break;
                    case ConsoleKey.NumPad4:
                    case ConsoleKey.D4:
                        testUploadStatAPI();
                        break;
                    case ConsoleKey.NumPad5:
                    case ConsoleKey.D5:
                        testDownloadLeaderboard();
                        break;
                    case ConsoleKey.NumPad6:
                    case ConsoleKey.D6:
                        testUploadLeaderboard();
                        break;
                    case ConsoleKey.NumPad7:
                    case ConsoleKey.D7:
                        testDownloadArcadeLeaderboard();
                        break;
                    case ConsoleKey.NumPad8:
                    case ConsoleKey.D8:
                        testUploadArcadeLeaderboard();
                        break;
                    case ConsoleKey.NumPad9:
                    case ConsoleKey.D9:
                        testArcadeSessionIsReady();
                        break;
                    case ConsoleKey.A:
                        testArcadeSessionStart();
                        break;
                    case ConsoleKey.B:
                        testArcadeSessionStop();
                        break;
                    case ConsoleKey.C:
                        testIAPIsReady();
                        break;
                    case ConsoleKey.D:
                        testIAPRequest();
                        break;
                    case ConsoleKey.E:
                        testIAPRequestWithUserData();
                        break;
                    case ConsoleKey.F:
                        testIAPPurchase();
                        break;
                    case ConsoleKey.G:
                        testIAPQuery();
                        break;
                    case ConsoleKey.H:
                        testIAPGetbalance();
                        break;
                    case ConsoleKey.I:
                        testIAPRequestSubscription();
                        break;
                    case ConsoleKey.J:
                        testIAPRequestSubscriptionwithplanID();
                        break;
                    case ConsoleKey.K:
                        testIAPsubscribe();
                        break;
                    case ConsoleKey.L:
                        testIAPQureysubscription();
                        break;
                    case ConsoleKey.M:
                        testIAPCancelsubscription();
                        break;
                    case ConsoleKey.N:
                        testQueryPurchaseList();
                        break;
                    case ConsoleKey.O:
                        testTokenIsReady();
                        break;
                    case ConsoleKey.P:
                        testGetSessionToken();
                        break;
                    case ConsoleKey.Escape:
                        Console.WriteLine("exit the game\n");
                        bexit = true;
                        break;
                    default:
                        Console.WriteLine("Invalid key press \n");
                        break;
                }
            } while (!bexit);

            return 1;
        }

        public static void displayMenuItems()
        {
            Console.WriteLine("==========================");
            Console.WriteLine("Main menu(api ver) ==> " + Api.Version());
            Console.WriteLine("0.Get License");
            Console.WriteLine("1.Isready");
            Console.WriteLine("2.Get UserId/UserName/UserAvatar");
            Console.WriteLine("3.Download Stat");
            Console.WriteLine("4.Upload Stat");
            Console.WriteLine("5.Download Leaderboard");
            Console.WriteLine("6.Upload Leaderboard");
            Console.WriteLine("7.Download Arcade Leaderboard");
            Console.WriteLine("8.Upload Arcade Leaderboard");
            Console.WriteLine("9.ArcadeSessionIsReady");
            Console.WriteLine("A.ArcadeSessionStart");
            Console.WriteLine("B.ArcadeSessionStop");
            Console.WriteLine("C.IAPIsReady");
            Console.WriteLine("D.IAPRequest");
            Console.WriteLine("E.IAPRequestWithUserData");
            Console.WriteLine("F.IAPPurchase");
            Console.WriteLine("G.IAPQuery");
            Console.WriteLine("H.IAPGetbalance");
            Console.WriteLine("I.IAPRequestSubscription");
            Console.WriteLine("J.IAPRequestSubscriptionwithplanID");
            Console.WriteLine("K.IAPsubscribe");
            Console.WriteLine("L.APQureysubscription");
            Console.WriteLine("M.IAPCancelsubscription");
            Console.WriteLine("N.QueryPurchaseList");
            Console.WriteLine("O.TokenIsReady");
            Console.WriteLine("P.GetSessionToken");
            Console.WriteLine("ESC.Quit test program");
            Console.WriteLine("please enter something:");
            Console.WriteLine("==========================");
        }

        private static void InitStatusHandler(int nResult)
        {
            Console.WriteLine("==== API Init Handler ====");
            if (nResult == 0)
                Console.WriteLine("Init Callback result is successful ");
            else
                Console.WriteLine("Init Callback result is fail");
            showMenu();
        }

        private static void IsReadyHandler(int nResult)
        {
            Console.WriteLine("==== UserStat IsReady ====");
            if (nResult == 0)
                Console.WriteLine("IsReadyHandler result is successful ");
            else
                Console.WriteLine("IsReadyHandler result is fail");
            showMenu();
        }

        private static void DownloadStatHandler(int nResult)
        {
            Console.WriteLine("==== UserStat DownloadStat ====");
            if (nResult == 0)
            {
                Console.WriteLine("DownloadStatHandler is successful");
                Console.WriteLine("GetStat ID_Stat1 result = " + UserStats.GetStat("ID_Stat1", 5));
                Console.WriteLine("SetStat ID_Stat1 result");
                UserStats.SetStat("ID_Stat1", 10);
                bool bAchievement = UserStats.GetAchievement("ID_Achievement1");
                Console.WriteLine("GetAchievement ID_Achievement1 result = " + bAchievement);
                if (bAchievement == true)
                {
                    int time = UserStats.GetAchievementUnlockTime("ID_Achievement1");
                    Console.WriteLine("GetAchievementUnlocktime is => " + time);
                    Console.WriteLine("ClearAchievement => " + UserStats.ClearAchievement("ID_Achievement1"));
                }
                else
                    Console.WriteLine("SetAchievement ID_Achievement1 result = " + UserStats.SetAchievement("ID_Achievement1"));

            }
            else
                Console.WriteLine("DownloadStatHandler is fail");
            showMenu();
        }

        private static void UploadStatHandler(int nResult)
        {
            Console.WriteLine("==== UserStat UploadStat ====");
            if (nResult == 0)
            {
                Console.WriteLine("UploadStatHandler is successful");
            }
            else
                Console.WriteLine("UploadStatHandler is fail");
            showMenu();
        }

        private static void DownloadLeaderboardHandler(int nResult)
        {
            Console.WriteLine("==== DownloadLeaderboard ====");
            if (nResult == 0)
            {
                Console.WriteLine("DownloadLeaderboardHandler is successful");
                Console.WriteLine("GetLeaderboardScoreCount => " + UserStats.GetLeaderboardScoreCount());
                Console.WriteLine("GetLeaderboardSortMethod => " + UserStats.GetLeaderboardSortMethod());
                Console.WriteLine("GetLeaderboardDisplayType => " + UserStats.GetLeaderboardDisplayType());
                for (int i = 1; i < UserStats.GetLeaderboardScoreCount(); i++)
                {
                    Leaderboard lbdata;
                    lbdata = UserStats.GetLeaderboardScore(i);
                    Console.WriteLine("UserName  => " + lbdata.UserName + ", Score => " + lbdata.Score + ", Rank => " + lbdata.Rank);
                }
            }
            else
                Console.WriteLine("DownloadLeaderboardHandler is fail");
            showMenu();
        }

        private static void UploadLeaderboardHandler(int nResult)
        {
            Console.WriteLine("==== UploadLeaderboardHandler ====");
            if (nResult == 0)
            {
                Console.WriteLine("UploadLeaderboardHandler is successful");
            }
            else
                Console.WriteLine("UploadLeaderboardHandler is fail");
            showMenu();
        }


        private static void DownloadArcadeLeaderboardHandler(int nResult)
        {
            Console.WriteLine("==== DownloadArcadeLeaderboard ====");
            if (nResult == 0)
            {
                Console.WriteLine("DownloadArcadeLeaderboardHandler is successful");
                Console.WriteLine("GetArcadeLeaderboardUserrank => " + ArcadeLeaderboard.GetLeaderboardUserRank());
                Console.WriteLine("GetArcadeLeaderboardScorecount => " + ArcadeLeaderboard.GetLeaderboardScoreCount());
                Console.WriteLine("GetArcadeLeaderboardUserScore => " + ArcadeLeaderboard.GetLeaderboardUserScore());
                for (int i = 1; i < ArcadeLeaderboard.GetLeaderboardScoreCount(); i++)
                {
                    Leaderboard lbdata;
                    lbdata = ArcadeLeaderboard.GetLeaderboardScore(i);
                    Console.WriteLine("UserName  => " + lbdata.UserName + ", Score => " + lbdata.Score + ", Rank => " + lbdata.Rank);
                }
            }
            else
                Console.WriteLine("DownloadArcadeLeaderboardHandler is fail");
            showMenu();
        }

        private static void UploadArcadeLeaderboardHandler(int nResult)
        {
            Console.WriteLine("==== UploadArcadeLeaderboardHandler ====");
            if (nResult == 0)
            {
                Console.WriteLine("UploadArcadeLeaderboardHandler is successful");
            }
            else
                Console.WriteLine("UploadArcadeLeaderboardHandler is fail");
            showMenu();
        }

        static void Main(string[] args)
        {
            Api.Init(InitStatusHandler, VIVEPORT_ID);

            //ConsoleKeyInfo keyinfo = Console.ReadKey();
            //if (keyinfo.Key == ConsoleKey.Escape)
            //    return;
            //else if (keyinfo.Key == ConsoleKey.NumPad8)
            //    Api.GetLicense(new MyLicenseChecker(), APP_ID, APP_KEY);*/
        }
    }


    class MyLicenseChecker : Api.LicenseChecker
    {
        public override void OnSuccess(long issueTime, long expirationTime, int latestVersion, bool updateRequired)
        {
            Viveport.Core.Logger.Log("[MyLicenseChecker] issueTime: " + issueTime);
            Viveport.Core.Logger.Log("[MyLicenseChecker] expirationTime: " + expirationTime);
            Viveport.Core.Logger.Log("[MyLicenseChecker] latestVersion: " + latestVersion);
            Viveport.Core.Logger.Log("[MyLicenseChecker] updateRequired: " + updateRequired);
            ViveportDemo.displayMenuItems();
        }

        public override void OnFailure(int errorCode, string errorMessage)
        {
            Viveport.Core.Logger.Log("[MyLicenseChecker] errorCode: " + errorCode);
            Viveport.Core.Logger.Log("[MyLicenseChecker] errorMessage: " + errorMessage);
            ViveportDemo.displayMenuItems();
        }
    }
    //public class Result : Session.SessionListener
    //{
    //    public override void OnSuccess(string pchAppID)
    //    {
    //        Viveport.Core.Logger.Log("[Session OnSuccess] pchAppID=" + pchAppID);
    //        ViveportDemo.displayMenuItems();
    //    }

    //    public override void OnStartSuccess(string pchAppID, string pchGuid)
    //    {
    //        Viveport.Core.Logger.Log("[Session OnStartSuccess] pchAppID=" + pchAppID + ",pchGuid=" + pchGuid);
    //        ViveportDemo.displayMenuItems();
    //    }

    //    public override void OnStopSuccess(string pchAppID, string pchGuid)
    //    {
    //        Viveport.Core.Logger.Log("[Session OnStopSuccess] pchAppID=" + pchAppID + ",pchGuid=" + pchGuid);
    //        ViveportDemo.displayMenuItems();
    //    }

    //    public override void OnFailure(int nCode, string pchMessage)
    //    {
    //        Viveport.Core.Logger.Log("[Session OnFailed] nCode=" + nCode + ",pchMessage=" + pchMessage);
    //        ViveportDemo.displayMenuItems();
    //    }
    //}

    public class Item
    {
        public string ticket = "test_id";
        public string[] items;
        public string subscription_ticket = "unity_test_subscriptionId";
    }

    public class IAPListener : IAPurchase.IAPurchaseListener
    {
        public Item mItem = new Item();

        public override void OnSuccess(string pchCurrencyName)
        {
            Viveport.Core.Logger.Log("[OnSuccess] pchCurrencyName=" + pchCurrencyName);
            ViveportDemo.displayMenuItems();
        }

        public override void OnRequestSuccess(string pchPurchaseId)
        {
            mItem.ticket = pchPurchaseId;
            Viveport.Core.Logger.Log("[OnRequestSuccess] pchPurchaseId=" + pchPurchaseId + ",mItem.ticket=" + mItem.ticket);
            ViveportDemo.displayMenuItems();
        }

        public override void OnPurchaseSuccess(string pchPurchaseId)
        {
            Viveport.Core.Logger.Log("[OnPurchaseSuccess] pchPurchaseId=" + pchPurchaseId);
            if (mItem.ticket == pchPurchaseId)//if stored id equals the purchase id which is returned by OnPurchaseSuccess(), give the virtual items to user
            {
                Viveport.Core.Logger.Log("[OnPurchaseSuccess] give items to user");
                //to implement: give virtual items to user
            }
            ViveportDemo.displayMenuItems();
        }

        public override void OnQuerySuccess(IAPurchase.QueryResponse response)
        {
            //when status equals "success", then this purchase is valid, you can deliver virtual items to user
            Viveport.Core.Logger.Log("[OnQuerySuccess] purchaseId=" + response.purchase_id + ",status=" + response.status);
            ViveportDemo.displayMenuItems();
        }

        public override void OnQuerySuccess(IAPurchase.QueryListResponse response)
        {
            //return all purchases which status equal to "success"
            Viveport.Core.Logger.Log("[OnQueryListSuccess] total=" + response.total + ",from=" + response.from + ",to=" + response.to);
            foreach (IAPurchase.QueryResponse2 qr in response.purchaseList)
            {
                Viveport.Core.Logger.Log("purchase_id=" + qr.purchase_id + ", user_data=" + qr.user_data + ", price=" + qr.price + ", currency=" + qr.currency +
                    ", paid_timestamp=" + qr.paid_timestamp);
            }
        }

        public override void OnBalanceSuccess(string pchBalance)
        {
            Viveport.Core.Logger.Log("[OnBalanceSuccess] pchBalance=" + pchBalance);
            ViveportDemo.displayMenuItems();
        }

        public override void OnRequestSubscriptionSuccess(string pchSubscriptionId)
        {
            mItem.subscription_ticket = pchSubscriptionId;
            Viveport.Core.Logger.Log("[OnRequestSubscriptionSuccess] pchSubscriptionId=" + pchSubscriptionId + ",mItem.subscription_ticket=" + mItem.subscription_ticket);
            ViveportDemo.displayMenuItems();
        }

        public override void OnRequestSubscriptionWithPlanIDSuccess(string pchSubscriptionId)
        {
            mItem.subscription_ticket = pchSubscriptionId;
            Viveport.Core.Logger.Log("[OnRequestSubscriptionWithPlanIDSuccess] pchSubscriptionId=" + pchSubscriptionId + ",mItem.subscription_ticket=" + mItem.subscription_ticket);
            ViveportDemo.displayMenuItems();
        }

        public override void OnSubscribeSuccess(string pchSubscriptionId)
        {
            Viveport.Core.Logger.Log("[OnSubscribeSuccess] pchSubscriptionId=" + pchSubscriptionId);
            if (mItem.subscription_ticket == pchSubscriptionId)
            {
                Viveport.Core.Logger.Log("[OnSubscribeSuccess] give virtual items to user");
                //to implement: give virtual items to user
            }
            ViveportDemo.displayMenuItems();
        }

        public override void OnQuerySubscriptionSuccess(IAPurchase.Subscription[] subscriptionlist)
        {
            int size = subscriptionlist.Length;
            bool bIsDuplicatedSubscription = false;

            Viveport.Core.Logger.Log("[OnQuerySubscriptionSuccess] subscriptionlist size =" + size);
            if (size > 0)
            {
                for (int i = 0; i < size; i++)
                {
                    //when status equals "ACTIVE", then this subscription is valid, you can deliver virtual items to user
                    Viveport.Core.Logger.Log("[OnQuerySubscriptionSuccess] subscriptionlist[" + i + "].status =" + subscriptionlist[i].status +
                        ", subscriptionlist[" + i + "].plan_id = " + subscriptionlist[i].plan_id);
                    if (subscriptionlist[i].plan_id == "pID" && subscriptionlist[i].status == "ACTIVE")
                    {
                        bIsDuplicatedSubscription = true;
                    }
                }
            }
            ViveportDemo.displayMenuItems();
        }

        public override void OnCancelSubscriptionSuccess(bool bCanceled)
        {
            Viveport.Core.Logger.Log("[OnCancelSubscriptionSuccess] bCanceled=" + bCanceled);
            ViveportDemo.displayMenuItems();
        }

        public override void OnFailure(int nCode, string pchMessage)
        {
            Viveport.Core.Logger.Log("[OnFailed] " + nCode + ", " + pchMessage);
            ViveportDemo.displayMenuItems();
        }
    }
}
